//----------------------------------------------------------------------------//
//                                         888                                //
//                                         888                                //
//                                         888                                //
//                         8888b.  888d888 888  888                           //
//                            `88b 888P'   888 .88P                           //
//                        .d888888 888     888888K                            //
//                        888  888 888     888 `88b                           //
//                        `Y888888 888     888  888                           //
//                                                                            //
//                                                                            //
//  File      : log_utils.mjs                                                 //
//  Project   : doom_fire                                                     //
//  Date      : 14 Dec, 21                                                    //
//  License   : GPLv3                                                         //
//  Author    : stdmatt <stdmatt@pixelwizards.io>                             //
//  Copyright : stdmatt - 2021                                                //
//                                                                            //
//  Description :                                                             //
//                                                                            //
//---------------------------------------------------------------------------~//
import { Str } from "./str.mjs";


function _log(type, ...args)
{
    const stack_trace = StackTrace.getSync();
    const info = stack_trace[4];
    const line = Str.format("[{}][{}]", type, info.functionName)
    console.log(line, ...args);
}

//----------------------------------------------------------------------------//
// Log_Utils                                                                  //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Log_Utils
{

    //--------------------------------------------------------------------------
    static log_always(...args)
    {
        _log("", ...args);
    }

    //--------------------------------------------------------------------------
    static log_debug(...args)
    {
        _log("DEBUG", ...args);
        debugger;
    }

    //--------------------------------------------------------------------------
    static log_verbose(...args)
    {
        _log("VERBOSE", ...args);
    }

    //--------------------------------------------------------------------------
    static log_error(...args)
    {
        _log("ERROR", ...args);
        debugger;
    }

    //--------------------------------------------------------------------------
    static log_warn(...args)
    {
        _log("WARN", ...args);
    }
}